<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/css/bootstrap.min.css"
        integrity="sha384-xOolHFLEh07PJGoPkLv1IbcEPTNtaed2xpHsD9ESMhqIYd0nLMwNLD69Npy4HI+N" crossorigin="anonymous">
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-icons@1.10.5/font/bootstrap-icons.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <link rel="preconnect" href="https://fonts.googleapis.com">
    <link rel="preconnect" href="https://fonts.gstatic.com" crossorigin>
    <link href="https://fonts.googleapis.com/css2?family=Squada+One&display=swap" rel="stylesheet">
    <link rel="stylesheet" href="style.css">
    <!-- data table -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.13.4/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.13.4/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.13.4/js/dataTables.bootstrap4.min.js"></script>
    <title>Admin</title>
</head>

<body>
    <div class="container">
        <div class="title text-center">
            <h4>DANH SÁCH ĐƠN HÀNG</h3>
        </div>
        <table id="order-table" class="table table-bordered table-primary table-hover table-striped">
            <thead class="">
                <tr>
                    <td>STT</td>
                    <td>Mã đơn hàng</td>
                    <td>Họ và tên</td>
                    <td>Payment Method</td>
                    <td>Số lượng sản phẩm</td>
                    <td>Tổng tiền</td>
                    <td>Ngày đặt hàng</td>
                    <td>Action</td>
                </tr>
            </thead>
            <tbody>

            </tbody>
        </table>
    </div>
    <!-- modal -->
    <div id="update-modal">
        <div id="create-update-modal" class="modal fade" tabindex="-1">
            <div class="modal-dialog modal-lg">
                <div class="modal-content lexend-deca">
                    <div class="modal-header text-center">
                        <div class="text-center">
                            <h3>CHI TIẾT ĐƠN HÀNG - MÃ:</h3>
                        </div>
                    </div>
                    <div class="modal-body">

                        <div class="row">
                            <div class="col-12 d-flex flex-column py-3">
                                <div class="row d-flex py-3">
                                    <div class="col-6 py-3 form-group d-flex align-items-center">
                                        <label class="col-5" for="inp-lastname">Họ và đệm <span
                                                class="text-danger">(*)</span></label>
                                        <input class="form-control" type="text" name="" id="inp-lastname">
                                    </div>
                                    <div class="col-6 form-group d-flex align-items-center">
                                        <label class="col-5" for="inp-firstname">Tên <span
                                                class="text-danger">(*)</span></label>
                                        <input class="form-control" type="text" name="" id="inp-firstname">
                                    </div>
                                </div>
                                <div class="row d-flex py-3">
                                    <div class="col-6 form-group d-flex align-items-center">
                                        <label class="col-5" for="inp-email">Email <span
                                                class="text-danger">(*)</span></label>
                                        <input class="form-control" type="text" name="" id="inp-email">
                                    </div>
                                    <div class="col-6 form-group d-flex align-items-center">
                                        <label class="col-5" for="inp-phone">Phone <span
                                                class="text-danger">(*)</span></label>
                                        <input class="form-control" type="text" name="" id="inp-phone">
                                    </div>
                                </div>
                                <div class="row d-flex py-3">
                                    <div class="col-12 form-group d-flex align-items-center">
                                        <label class="pl-3" for="inp-address" style="width: 25%;">Address <span
                                                class="text-danger">(*)</span></label>
                                        <input class="form-control" type="text" name="" id="inp-address">
                                    </div>
                                </div>
                                <div class="row">
                                    <div class="col-6 form-group d-flex align-items-center">
                                        <label class="col-5" for="select-payment-method">Payment method <span class="text-danger">(*)</span></label>
                                        <select class="form-control" name="" id="select-payment-method">
                                            <option value="Paypal">Paypal</option>
                                            <option value="CreditCard">Credit Card</option>
                                            <option value="BankTransfer">Bank Transfer</option>
                                        </select>
                                    </div>
                                    <div class="col-6 form-group d-flex align-items-center">
                                        <label class="col-5" for="inp-voucher">Mã giảm giá <span
                                                class="text-danger">(*)</span></label>
                                        <input class="form-control" type="text" name="" id="inp-voucher">

                                    </div>
                                    <div class="col-12 d-flex align-items-center  justify-content-end">

                                        <p class="text-right">(Được giảm: <span style="font-weight: 500;" id="span-discount">0</span>%)</p>
                                    </div>
                                </div>

                            </div>
                        </div>
                    </div>
                    <div class="modal-footer">
                        <div class="text-right">
                            <button id="modal-btn-cancel" class="btn btn-dark">Hủy</button>
                            <button id="modal-btn-update" class="btn btn-success">Cập nhật</button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
</body>
<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    $(document).ready(function () {
        const gBASE_URL = "https://food-ordering-fvo9.onrender.com/api";

        const gNAME_COL = ["STT", "orderCode", "firstName", "lastName", "methodPayment", "foods", "price", "date", "action"]
        const gSTT_COL = 0;
        const gODER_CODE_COL = 1;
        const gFIRST_NAME_COL = 2;
        const gLAST_NAME_COL = 3;
        const gPAYMENT_METHOD_COL = 4;
        const gQUANTITY_COL = 5;
        const gPRICE_COL = 6;
        const gDATE_COL = 7;
        const gACTION_COL = 8;
        var gSTT = 0;
        var gOderDataTable = $("#order-table").DataTable({
            columns: [
                { data: 'id' },
                { data: 'orderCode' },
                { data: { firstName: "firstName", lastName: "lastName" } },
                { data: 'methodPayment' },
                { data: 'foods' },
                { data: 'foods' },//tổng tiền
                { data: 'createdAt' },
                { data: 'action' }
            ],
            columnDefs: [
                {
                    targets: 0,
                    render: renderSTT
                },
                {
                    targets: 2,
                    render: renderFullname
                },
                {
                    targets: 4,
                    render: renderQuantity
                },
                {
                    targets: 5,
                    render: renderPrice
                },
                {
                    targets: 7,
                    defaultContent: `
            <img class="edit-order" src="https://cdn0.iconfinder.com/data/icons/glyphpack/45/edit-alt-512.png" style="width: 20px;cursor:pointer;">
            <img class="delete-order" src="https://cdn4.iconfinder.com/data/icons/complete-common-version-6-4/1024/trash-512.png" style="width: 20px;cursor:pointer;">
            `
                }

            ]
        });
        var gVoucher = [];
        var gOrderId = ""

        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
        //thực thi sự kiện load trang:
        onPageLoading();
        //hàm thực thi nút ấn edit btn
        $("#order-table").on("click", ".edit-order", function () {
            onBtnEditOderClick(this);
        });

        //hàm thực thi nút ấn delete btn
        $("#order-table").on("click", ".delete-order", function () {
            onBtnDeleteOderClick(this);
        });

        //hàm thực thi ấn nút cập nhật trên modal:
        $("#create-update-modal").on("click", "#modal-btn-update", function () {
            onBtnModalUpdateClick()
        })
         //hàm thực thi ấn nút hủy trên modal:
         $("#create-update-modal").on("click", "#modal-btn-cancel", function () {
            $("#create-update-modal").modal("hide")
        })
        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        //hàm sự kiện load trang
        function onPageLoading() {
            callApiToGetOrderList();
            getVoucher();
        };
        //hàm ấn nút edit order:
        function onBtnEditOderClick(paramEditBtn) {
            var vTableRow = $(paramEditBtn).parents("tr");
            var vDataTableRow = gOderDataTable.row(vTableRow).data();
            var vOrderId = vDataTableRow.id;
            gOrderId = vOrderId;
            console.log(gOrderId);
            loadDataToModal(vDataTableRow)
            $("#create-update-modal").modal("show")
        };

        //hàm ấn nút delete order:
        function onBtnDeleteOderClick(paramEditBtn) {
            var vTableRow = $(paramEditBtn).parents("tr");
            var vDataTableRow = gOderDataTable.row(vTableRow);
            var vOrderId = vDataTableRow.data().id
            console.log(vOrderId)
        };
        //hàm ấn nút update trên modal:
        function onBtnModalUpdateClick() {
            var vOrderData = {
                firstName: "",
                lastName: "",
                email: "",
                phone: "",
                address: "",
                methodPayment: "",
                voucherId: "",
            }
            //B1: thu thập dữ liệu:
            readOderData(vOrderData);
            console.log(vOrderData);
            //B2: validate dữ liệu:
            var vDulieuHopLe = validateOrderData(vOrderData);
            if (vDulieuHopLe) {
                //B3: goi Api
                callApiToUpdateOrder(vOrderData)
            }

        }

        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        //hàm gọi api lấy danh sách order:
        //hàm render STT:
        function renderSTT() {
            gSTT++
            return gSTT
        };

        function renderFullname(paramArr) {
            return `${paramArr.firstName} ${paramArr.lastName}`
        }

        function renderQuantity(paramFoodArr) {
            return paramFoodArr.length;
        }
        // function renderPrice(paramFoodsArr) {
        //     var vTotal = 0;
        //     for (var paramFoodsArr of paramFoodsArr) {
        //         vTotal += paramFoodsArr.price
        //     }

        //     return vTotal
        // }
        // function renderPrice(paramFoodsArr) {
        //     var vTotal = 0;
        //     for (var bI = 0; bI < paramFoodsArr.length; bI++) {
        //         vTotal += paramFoodsArr[bI].price
        //     } 
        //     return vTotal
        // }
        // function countPrice (total, curPrice) {
        //    return total += curPrice.price;
        // }
        function renderPrice(paramFoodsArr) {
            var vTotal = paramFoodsArr.reduce(function (total, curPrice) {
                return total += curPrice.price;
            }, 0)
            return vTotal
        }


        function callApiToGetOrderList() {
            $.ajax({
                url: gBASE_URL + "/orders/",
                type: "GET",
                success: function (paramRes) {
                    console.log(paramRes);
                    loadUserListToTable(paramRes)
                },
                error: function (paramError) {
                    console.log(paramError.responseText)
                }
            });
        };
        function loadUserListToTable(paramOrderObj) {
            gOderDataTable.clear(),
                gOderDataTable.rows.add(paramOrderObj),
                gOderDataTable.draw()
        }

        //load data table row into modal
        function loadDataToModal(paramData) {
            var vVoucher = checkVoucher(paramData.voucherId)
            $("#order-code").html(paramData.orderCode.trim());
            $("#inp-lastname").val(paramData.lastName.trim());
            $("#inp-firstname").val(paramData.firstName.trim());
            $("#inp-email").val(paramData.email.trim());
            $("#inp-phone").val(paramData.phone.trim());
            $("#inp-address").val(paramData.address.trim());
            $("#select-payment-method").val(paramData.methodPayment);
            $("#inp-voucher").val(vVoucher.voucherCode);
            $("#span-discount").html(vVoucher.discount);

        }
        //hàm lấy voucher list
        function getVoucher() {
            // var vOrderId = JSON.stringify(paramVoucherId);
            $.ajax({
                url: gBASE_URL + "/vouchers/",
                type: "GET",
                success: function (paramRes) {
                    gVoucher = paramRes;
                },
                error: function (paramErorr) {
                    console.log(paramErorr.responseText);
                }
            })
            return gVoucher
        };
        //hàm kiểm tra voucher:
        function checkVoucher(paramVoucherId) {
            console.log(gVoucher)
            var bVoucherCorrect = {};
            if (paramVoucherId != null) {
                for (var bI = 0; bI < gVoucher.length; bI++) {
                    if (paramVoucherId == gVoucher[bI].id) {
                        bVoucherCorrect = {
                            voucherCode: gVoucher[bI].voucherCode,
                            discount: gVoucher[bI].discount,
                        };
                    }
                }
            } else {
                bVoucherCorrect = {
                    voucherCode: "",
                    discount: 0
                }
            }
            return bVoucherCorrect
        };
        // xử lý sự kiện trong modal update:
        //B1: thu thập dữ liệu:
        function readOderData(paramOrderData) {
            paramOrderData.firstName = ($("#inp-firstname").val()).trim();
            paramOrderData.lastName = ($("#inp-lastname").val()).trim();
            paramOrderData.email = ($("#inp-email").val()).trim();
            paramOrderData.phone = ($("#inp-phone").val()).trim();
            paramOrderData.address = ($("#inp-address").val()).trim();
            paramOrderData.methodPayment = $("#select-payment-method").val();
            paramOrderData.voucherId = getVoucherIdByVoucherCode($("#inp-voucher").val());

        };
        //hàm lấy voucher ID by voucherCode
        function getVoucherIdByVoucherCode(paramVoucherCode) {
            var vVoucherId;
            if (paramVoucherCode != null) {
                for (let bI = 0; bI < gVoucher.length; bI++) {
                    if (paramVoucherCode == gVoucher[bI].voucherCode) {
                        vVoucherId = gVoucher[bI].id
                    }
                }
            } else {
                vVoucherId = "";
            }
            return vVoucherId
        };
        //hàm validate dữ liệu:
        function validateOrderData(paramOrderData) {
            if (paramOrderData.orderCode == '') {
                alert('Hãy nhập mã đơn hàng')
                return false
            }
            if (paramOrderData.firstName == '') {
                alert('Hãy nhập tên')
                return false
            }
            if (paramOrderData.lastName == '') {
                alert('Hãy nhập họ và tên đệm')
                return false
            }
            if (paramOrderData.email == '' || !validateEmail(paramOrderData.email)) {
                alert('Hãy nhập email đúng định dạng')
                return false
            }
            if (paramOrderData.phone == '' || !validatePhone(paramOrderData.phone)) {
                alert('Hãy nhập số điện thoại đúng định dạng')
                return false
            }
            if (paramOrderData.address == '') {
                alert('Hãy nhập địa chỉ')
                return false
            }
            if (paramOrderData.methodPayment == null) {
                alert('Hãy chọn phương thức thanh toán')
                return false
            }
            return true
        };
        //B3: call api to update order:
        function callApiToUpdateOrder(paramOrderData) {
            $.ajax({
                url: gBASE_URL + "/orders/" + gOrderId,
                type: "PUT",
                headers: {
                    'Accept': 'application/json',
                    'Content-Type': 'application/json'
                },
                data: JSON.stringify(paramOrderData),
                success: function (paramRes) {
                    console.log(paramRes);
                    handleUpdateOrder()

                },
                error: function (paramError) {
                    console.log(paramError.responseText);
                }
            });
        };
        //hàm validate email
        const validateEmail = (paramEmail) => {
            var vRegexEmail = /^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,3})+$/
            var vCheckedEmail = vRegexEmail.test(paramEmail)
            return vCheckedEmail
        };

        //hàm validate phone
        const validatePhone = (paramPhone) => {
            var vRegexPhone = /^\(?([0-9]{3})\)?[-. ]?([0-9]{3})[-. ]?([0-9]{4})$/
            var vCheckedPhone = paramPhone.match(vRegexPhone)
            return vCheckedPhone
        };
        //hàm xóa trắng modal update:
        function resertUpdateModal() {
            $("#inp-firstname").val("");
            $("#inp-lastname").val("");
            $("#inp-email").val("");
            $("#inp-phone").val("");
            $("#inp-address").val("");
            $("#select-payment-method").val("0");
            $("#inp-voucher").val("");
        };
        //hàm xử lý khi update order thành công:
        function handleUpdateOrder() {
            alert("Cập nhật order thành công");
            resertUpdateModal();
            $("#create-update-modal").modal("hide");
            location.reload()

        }
    });
</script>

</html>